<?php 


if (!defined('_ECRIRE_INC_VERSION')) return;
 
 include_spip('inc/actions');
 include_spip('inc/editer');
 
 
	      
/*
  * Déclaration des champs du formulaire
  */
function formulaires_editer_pdform_patron_saisies_dist($id_pdform_patron='new', $retour='', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	$id_pdform = intval($id_pdform_patron);

	$saisies = array(
		array( // le fieldset racine général
			'saisie' => 'fieldset',
			'options' => array(
				'nom' => 'general',
				'label' => _T('pdform_patron:fieldset_global'),
			),
			'saisies' => array( // les champs dans le fieldset 
				array(
					'saisie' => 'input', // titre
					'options' => array(
						'nom' => 'titre',
						'label' => _T('pdform_patron:champ_titre_label'),
						'explication' => _T('pdform_patron:champ_titre_explication'),
					),
				),
				'verifier' => array(
					'type' => 'taille',
					'options' => array(
						'maxi' => '255',
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'orientation',
						'label' => _T('pdform_patron:champ_orientation_label'),
						'explication' => _T('pdform_patron:champ_orientation_explication'),
						'cacher_option_intro' => 'oui', // Il est obligatoire d'avoir une orientation
						'defaut' => 'P',
						'data' => array(
							'P' => _T('pdform_patron:data_orientation_P'),
							'L' => _T('pdform_patron:data_orientation_L')
						)
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'format',
						'label' => _T('pdform_patron:champ_format_label'),
						'explication' => _T('pdform_patron:champ_format_explication'),
						'cacher_option_intro' => 'oui', // Il est obligatoire d'avoir un format
						'defaut' => 'A4',
						'data' => array(
							'A10' => _T('pdform_patron:data_format_A10'),
							'A9' => _T('pdform_patron:data_format_A9'),
							'A8' => _T('pdform_patron:data_format_A8'),
							'A7' => _T('pdform_patron:data_format_A7'),
							'A6' => _T('pdform_patron:data_format_A6'),
							'A5' => _T('pdform_patron:data_format_A5'),
							'A4' => _T('pdform_patron:data_format_A4'),
							'A3' => _T('pdform_patron:data_format_A3'),
							'A2' => _T('pdform_patron:data_format_A2'),
							'A1' => _T('pdform_patron:data_format_A1'),
							'A0' => _T('pdform_patron:data_format_A0'),
						),
					),
				),
				array(
					'saisie' => 'input', // pages
					'options' => array(
						'nom' => 'pages',
						'label' => _T('pdform_patron:champ_pages_label'),
						'explication' => _T('pdform_patron:champ_pages_explication'),
						'defaut' => '1',
					),
				),
				array(
					'saisie' => 'pdform_polices',
					'options' => array(
						'nom' => 'police',
						'label' => _T('pdform_patron:champ_police_label'),
						'explication' => _T('pdform_patron:champ_police_explication'),
						'cacher_option_intro' => 'oui', // Il est obligatoire d'appeler cette méthode au moins une fois
						'defaut' => 'helvetica',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'taille',
						'label' => _T('pdform_patron:champ_taille_label'),
						'explication' => _T('pdform_patron:champ_taille_explication'),
						'defaut' => '12',
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'style',
						'label' => _T('pdform_patron:champ_style_label'),
						'explication' => _T('pdform_patron:champ_style_explication'),
						'cacher_option_intro' => 'oui',
						'defaut' => '',
						'data' => array(
							'' => _T('pdform_patron:data_fontstyle_'),
							'B' => _T('pdform_patron:data_fontstyle_b'),
							'U' => _T('pdform_patron:data_fontstyle_u'),
							'I' => _T('pdform_patron:data_fontstyle_i'),
						),
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'couleur_texte',
						'label' => _T('pdform_patron:champ_couleur_texte_label'),
						'explication' => _T('pdform_patron:champ_couleur_texte_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'couleur_trace',
						'label' => _T('pdform_patron:champ_couleur_trace_label'),
						'explication' => _T('pdform_patron:champ_couleur_trace_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'couleur_rempli',
						'label' => _T('pdform_patron:champ_couleur_rempli_label'),
						'explication' => _T('pdform_patron:champ_couleur_rempli_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
			),
		),
		array( // le fieldset de la définition des en-têtes
			'saisie' => 'fieldset',
			'options' => array(
				'nom' => 'etape_1',
				'label' => _T('pdform_patron:fieldset_entete'),
				'pliable' => 'oui',
				'plie' => 'oui'
			),
			'saisies' => array( // les champs dans le fieldset 
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_texte',
						'label' => _T('pdform_patron:champ_texte_label'),
						'explication' => _T('pdform_patron:champ_entete_texte_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_pages',
						'label' => _T('pdform_patron:champ_pages_label'),
						'explication' => _T('pdform_patron:champ_entete_pages_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_x',
						'label' => _T('pdform_patron:champ_x_label'),
						'explication' => _T('pdform_patron:champ_y_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_y',
						'label' => _T('pdform_patron:champ_y_label'),
						'explication' => _T('pdform_patron:champ_y_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_largeur',
						'label' => _T('pdform_patron:champ_largeur_label'),
						'explication' => _T('pdform_patron:champ_largeur_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_hauteur',
						'label' => _T('pdform_patron:champ_hauteur_label'),
						'explication' => _T('pdform_patron:champ_hauteur_explication'),
					),
				),
				array(
					'saisie' => 'pdform_polices',
					'options' => array(
						'nom' => 'entete_police',
						'label' => _T('pdform_patron:champ_police_label'),
						'explication' => _T('pdform_patron:champ_police_explication'),
						#'cacher_option_intro' => 'oui', // par défaut, ce sera les paramètres de 
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_taille',
						'label' => _T('pdform_patron:champ_taille_label'),
						'explication' => _T('pdform_patron:champ_taille_explication'),
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'entete_style',
						'label' => _T('pdform_patron:champ_style_label'),
						'explication' => _T('pdform_patron:champ_style_explication'),
						'cacher_option_intro' => 'oui',
						'data' => array(
							'' => _T('pdform_patron:data_fontstyle_'),
							'B' => _T('pdform_patron:data_fontstyle_b'),
							'U' => _T('pdform_patron:data_fontstyle_u'),
							'I' => _T('pdform_patron:data_fontstyle_i'),
						),
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'entete_couleur_texte',
						'label' => _T('pdform_patron:champ_couleur_texte_label'),
						'explication' => _T('pdform_patron:champ_couleur_texte_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'entete_couleur_trace',
						'label' => _T('pdform_patron:champ_couleur_trace_label'),
						'explication' => _T('pdform_patron:champ_couleur_trace_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'entete_couleur_rempli',
						'label' => _T('pdform_patron:champ_couleur_rempli_label'),
						'explication' => _T('pdform_patron:champ_couleur_rempli_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'entete_bordure',
						'label' => _T('pdform_patron:champ_bordure_label'),
						'explication' => _T('pdform_patron:champ_bordure_explication'),
						'cacher_option_intro' => 'oui',
						#'multiple' => 'non',
						'data' => array(
							'0' => _T('pdform_patron:data_border_0'),
							'1' => _T('pdform_patron:data_border_1'),
							'L' => _T('pdform_patron:data_border_l'),
							'T' => _T('pdform_patron:data_border_t'),
							'R' => _T('pdform_patron:data_border_r'),
							'B' => _T('pdform_patron:data_border_b'),
						),
					),
				),
				'verifier' => array( // les valeurs peuvent être 0|1|L|T|R|B
					'type' => 'regex',
					'options' => array(
						'modele' => '@^[0-1L|T|R|B]$@',
						'message_erreur' => _T('pdform_patron:message_erreur_regex_bordure'),
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'entete_apres',
						'label' => _T('pdform_patron:champ_apres_label'),
						'explication' => _T('pdform_patron:champ_apres_explication'),
						'cacher_option_intro' => 'oui',
						'defaut' => '2', // en dessous (utile si cell avec des retours à la ligne)
						'data' => array(
							'0' => _T('pdform_patron:data_ln_0'),
							'1' => _T('pdform_patron:data_ln_1'),
							'2' => _T('pdform_patron:data_ln_2'),
						),
					),
				),
				'verifier' => array( // les valeurs peuvent être 0|1|2
					'type' => 'regex',
					'options' => array(
						'modele' => '@^[0-2]$@',
						'message_erreur' => _T('pdform_patron:message_erreur_regex_apres'),
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'entete_align',
						'label' => _T('pdform_patron:champ_align_label'),
						'explication' => _T('pdform_patron:champ_align_explication'),
						'cacher_option_intro' => 'oui',
						#'multiple' => 'non',
						'data' => array(
							'L' => _T('pdform_patron:data_align_l'),
							'C' => _T('pdform_patron:data_align_c'),
							'R' => _T('pdform_patron:data_align_r'),
						),
					),
				),
				'verifier' => array( // la valeur peuvent être L|C|R
					'type' => 'regex',
					'options' => array(
						'modele' => '@^[L|C|R]$@',
						'message_erreur' => _T('pdform_patron:message_erreur_regex_align'),
					),
				),
				array(
					'saisie' => 'case',
					'options' => array(
						'nom' => 'entete_rempli',
						'label' => _T('pdform_patron:champ_rempli_label'),
						'explication' => _T('pdform_patron:champ_rempli_explication'),
						'valeur_oui' => '1',
						'valeur_non' => '0',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'entete_lien',
						'label' => _T('pdform_patron:champ_lien_label'),
						'explication' => _T('pdform_patron:champ_lien_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'url',
				),
			),
		),
		array( // le fieldset de la définition des pieds de page
			'saisie' => 'fieldset',
			'options' => array(
				'nom' => 'pied',
				'label' => _T('pdform_patron:fieldset_pied'),
				'pliable' => 'oui',
				'plie' => 'oui'
			),
			'saisies' => array( // les champs dans le fieldset 
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_texte',
						'label' => _T('pdform_patron:champ_texte_label'),
						'explication' => _T('pdform_patron:champ_pied_texte_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_pages',
						'label' => _T('pdform_patron:champ_pages_label'),
						'explication' => _T('pdform_patron:champ_entete_pages_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_x',
						'label' => _T('pdform_patron:champ_x_label'),
						'explication' => _T('pdform_patron:champ_y_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_y',
						'label' => _T('pdform_patron:champ_y_label'),
						'explication' => _T('pdform_patron:champ_y_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_largeur',
						'label' => _T('pdform_patron:champ_largeur_label'),
						'explication' => _T('pdform_patron:champ_largeur_explication'),
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_hauteur',
						'label' => _T('pdform_patron:champ_hauteur_label'),
						'explication' => _T('pdform_patron:champ_hauteur_explication'),
					),
				),
				array(
					'saisie' => 'pdform_polices',
					'options' => array(
						'nom' => 'pied_police',
						'label' => _T('pdform_patron:champ_police_label'),
						'explication' => _T('pdform_patron:champ_police_explication'),
						#'cacher_option_intro' => 'oui',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_taille',
						'label' => _T('pdform_patron:champ_taille_label'),
						'explication' => _T('pdform_patron:champ_taille_explication'),
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'pied_style',
						'label' => _T('pdform_patron:champ_style_label'),
						'explication' => _T('pdform_patron:champ_style_explication'),
						'cacher_option_intro' => 'oui',
						'data' => array(
							'' => _T('pdform_patron:data_fontstyle_'),
							'B' => _T('pdform_patron:data_fontstyle_b'),
							'U' => _T('pdform_patron:data_fontstyle_u'),
							'I' => _T('pdform_patron:data_fontstyle_i'),
						),
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'pied_couleur_texte',
						'label' => _T('pdform_patron:champ_couleur_texte_label'),
						'explication' => _T('pdform_patron:champ_couleur_texte_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'pied_couleur_trace',
						'label' => _T('pdform_patron:champ_couleur_trace_label'),
						'explication' => _T('pdform_patron:champ_couleur_trace_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'couleur',
					'options' => array(
						'nom' => 'pied_couleur_rempli',
						'label' => _T('pdform_patron:champ_couleur_rempli_label'),
						'explication' => _T('pdform_patron:champ_couleur_rempli_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'couleur',	
					'options' => array(
						'type' => 'hexa',
						'normaliser' => 'oui'
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'pied_bordure',
						'label' => _T('pdform_patron:champ_bordure_label'),
						'explication' => _T('pdform_patron:champ_bordure_explication'),
						'cacher_option_intro' => 'oui',
						#'multiple' => 'non',
						'data' => array(
							'0' => _T('pdform_patron:data_border_0'),
							'1' => _T('pdform_patron:data_border_1'),
							'L' => _T('pdform_patron:data_border_l'),
							'T' => _T('pdform_patron:data_border_t'),
							'R' => _T('pdform_patron:data_border_r'),
							'B' => _T('pdform_patron:data_border_b'),
						),
					),
				),
				'verifier' => array( // les valeurs peuvent être 0|1|L|T|R|B
					'type' => 'regex',
					'options' => array(
						'modele' => '@^[0-1L|T|R|B]$@',
						'message_erreur' => _T('pdform_patron:message_erreur_regex_bordure'),
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'pied_apres',
						'label' => _T('pdform_patron:champ_apres_label'),
						'explication' => _T('pdform_patron:champ_apres_explication'),
						'cacher_option_intro' => 'oui',
						'defaut' => '2', // en dessous (utile si cell avec des retours à la ligne)
						'data' => array(
							'0' => _T('pdform_patron:data_ln_0'),
							'1' => _T('pdform_patron:data_ln_1'),
							'2' => _T('pdform_patron:data_ln_2'),
						),
					),
				),
				'verifier' => array( // les valeurs peuvent être 0|1|2
					'type' => 'regex',
					'options' => array(
						'modele' => '@^[0-2]$@',
						'message_erreur' => _T('pdform_patron:message_erreur_regex_apres'),
					),
				),
				array(
					'saisie' => 'selection',
					'options' => array(
						'nom' => 'pied_align',
						'label' => _T('pdform_patron:champ_align_label'),
						'explication' => _T('pdform_patron:champ_align_explication'),
						'cacher_option_intro' => 'oui',
						#'multiple' => 'non',
						'data' => array(
							'L' => _T('pdform_patron:data_align_l'),
							'C' => _T('pdform_patron:data_align_c'),
							'R' => _T('pdform_patron:data_align_r'),
						),
					),
				),
				'verifier' => array( // la valeur peuvent être L|C|R
					'type' => 'regex',
					'options' => array(
						'modele' => '@^[L|C|R]$@',
						'message_erreur' => _T('pdform_patron:message_erreur_regex_align'),
					),
				),
				array(
					'saisie' => 'case',
					'options' => array(
						'nom' => 'pied_rempli',
						'label' => _T('pdform_patron:champ_rempli_label'),
						'explication' => _T('pdform_patron:champ_rempli_explication'),
						'valeur_oui' => '1',
						'valeur_non' => '0',
					),
				),
				array(
					'saisie' => 'input',
					'options' => array(
						'nom' => 'pied_lien',
						'label' => _T('pdform_patron:champ_lien_label'),
						'explication' => _T('pdform_patron:champ_lien_explication'),
					),
				),
				'verifier' => array( // tous les types d'url
					'type' => 'url',
				),
			),
		),
	);
	
	return $saisies;
}

/**
  * Identifier le formulaire en faisant abstraction des parametres qui ne representent pas l'objet edite
  */
function formulaires_editer_pdform_patron_identifier_dist($id_pdform_patron='new', $retour='', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	return serialize(array(intval($id_pdform_patron)));
}
 
/**
  * Declarer les champs postes et y integrer les valeurs par defaut
  */
function formulaires_editer_pdform_patron_charger_dist($id_pdform_patron='new', $retour='', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	$valeurs = formulaires_editer_objet_charger('pdform_patron',$id_pdform_patron,'',$lier_trad,$retour,$config_fonc,$row,$hidden);

	return $valeurs;
}

/**
  * Verifier les champs postes et signaler d'eventuelles erreurs
  */
 function formulaires_editer_pdform_patron_verifier_dist($id_pdform_patron='new', $retour='', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){
	 $erreurs = array();//formulaires_editer_objet_verifier('abonnement',$id_abonnement);
	return $erreurs;
}

/**
  * Traiter les champs postes
  */
function formulaires_editer_pdform_patron_traiter_dist($id_pdform_patron='new', $retour='', $lier_trad=0, $config_fonc='', $row=array(), $hidden=''){

	$retours = formulaires_editer_objet_traiter('pdform_patron',$id_pdform_patron,'',$lier_trad,$retour,$config_fonc,$row,$hidden);

	return $retours;

}

?>